Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_server_source_filter.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_server_source_filter.hpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_server_source_filter.hpp	(revision 1930)
@@ -0,0 +1,53 @@
+#ifndef __XIOS_CLIENT_FROM_SERVER_SOURCE_FILTER__
+#define __XIOS_CLIENT_FROM_SERVER_SOURCE_FILTER__
+
+#include <map>
+
+#include "output_pin.hpp"
+#include "event_server.hpp"
+#include "calendar_util.hpp"
+
+
+namespace xios
+{
+  class CGrid;
+  class CField;
+
+  /*!
+   * A source filter is the entry point of the data in the graph of filters.
+   */
+  class CClientFromServerSourceFilter : public COutputPin
+  {
+    public:
+      /*!
+       * Constructs a source filter accepting data attached to the specified grid.
+       *
+       * \param gc the garbage collector associated with this filter
+       * \param field associated to the filter
+       */
+      CClientFromServerSourceFilter(CGarbageCollector& gc, CField* field);
+
+      /*!
+       * Transforms the data received from the model into a packet and send it
+       * in the filter graph. The array containing the data can safely be reused
+       * immediately after this method returns.
+       *
+       * \param event the event coming from server with the associated data
+       */
+      void streamData(CEventServer& event);
+      bool isDataLate(void) ;
+      bool isEOF() {return isEOF_ ;}
+
+     private:
+      CGrid* grid_;             //!< The grid attached to the data the filter can accept
+      CDuration freqOp_ ;
+      CDuration offset_ ;
+
+      bool wasDataAlreadyReceived_= false ;
+      CDate lastDateReceived_ ;
+      bool isEOF_ = false ;
+      CDate dateEOF_ ;
+  }; // class CClientFromServerSourceFilter
+} // namespace xios
+
+#endif //__XIOS_CLIENT_FROM_SERVER_SOURCE_FILTER__
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_to_model_store_filter.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_to_model_store_filter.cpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_to_model_store_filter.cpp	(revision 1930)
@@ -0,0 +1,131 @@
+#include "client_to_model_store_filter.hpp"
+#include "context.hpp"
+#include "grid.hpp"
+#include "timer.hpp"
+#include "tracer.hpp"
+
+namespace xios
+{
+  CClientToModelStoreFilter::CClientToModelStoreFilter(CGarbageCollector& gc, CField* field)
+    : CInputPin(gc, 1)
+    , gc_(gc)
+  {
+    context_ = CContext::getCurrent() ;
+    grid_ = field->getGrid() ;
+
+    detectMissingValues_ = (!field->detect_missing_value.isEmpty() && !field->default_value.isEmpty() && field->detect_missing_value == true);
+    hasMissingValue_ = !field->default_value.isEmpty() ;
+    if (hasMissingValue_) missingValue_  = field->default_value ;
+    detectMissingValues_ = (!field->detect_missing_value.isEmpty() && hasMissingValue_);
+  }
+
+  CConstDataPacketPtr CClientToModelStoreFilter::getPacket(Time timestamp)
+  {
+    CTimer timer("CStoreFilter::getPacket");
+//    timer.resume(); 
+    info(0)<<"ENTERING CStoreFilter::getPacket"<<std::endl ;
+    traceOff() ;
+//    timer.suspend();
+    CConstDataPacketPtr packet;
+    const double timeout = CXios::recvFieldTimeout;
+
+    do
+    {
+      if (canBeTriggered()) trigger(timestamp);
+
+      timer.resume();
+
+      std::map<Time, CDataPacketPtr>::const_iterator it = packets_.find(timestamp);
+      if (it != packets_.end()) packet = it->second;
+      else  context_->eventLoop(); // if the packet is not available yet, check if it can be received
+
+      timer.suspend();
+    } while (!packet && timer.getCumulatedTime() < timeout);
+//    timer.resume();
+    traceOn() ;
+//    timer.suspend();
+
+    if (!packet)
+    {
+      std::map<Time, CDataPacketPtr>::const_iterator it ;
+      info(0)<<"Impossible to get the packet with timestamp = " << timestamp<<std::endl<<"Available timestamp are : "<<std::endl ;
+      for(it=packets_.begin();it!=packets_.end();++it) info(0)<<it->first<<"  ";
+      info(0)<<std::endl ;
+      ERROR("CConstDataPacketPtr CStoreFilter::getPacket(Time timestamp) const",
+            << "Impossible to get the packet with timestamp = " << timestamp);
+    }
+    return packet;
+  }
+
+  template <int N>
+  CDataPacket::StatusCode CClientToModelStoreFilter::getData(Time timestamp, CArray<double, N>& data)
+  {
+    CConstDataPacketPtr packet = getPacket(timestamp);
+
+    if (packet->status == CDataPacket::NO_ERROR)
+    {
+      if (hasMissingValue_) grid_->getWorkflowToModelConnector()->transfer(packet->data, data, missingValue_);
+      else grid_->getWorkflowToModelConnector()->transfer(packet->data, data);
+    }
+    return packet->status;
+  }
+
+  template CDataPacket::StatusCode CClientToModelStoreFilter::getData<1>(Time timestamp, CArray<double, 1>& data);
+  template CDataPacket::StatusCode CClientToModelStoreFilter::getData<2>(Time timestamp, CArray<double, 2>& data);
+  template CDataPacket::StatusCode CClientToModelStoreFilter::getData<3>(Time timestamp, CArray<double, 3>& data);
+  template CDataPacket::StatusCode CClientToModelStoreFilter::getData<4>(Time timestamp, CArray<double, 4>& data);
+  template CDataPacket::StatusCode CClientToModelStoreFilter::getData<5>(Time timestamp, CArray<double, 5>& data);
+  template CDataPacket::StatusCode CClientToModelStoreFilter::getData<6>(Time timestamp, CArray<double, 6>& data);
+  template CDataPacket::StatusCode CClientToModelStoreFilter::getData<7>(Time timestamp, CArray<double, 7>& data);
+
+  void CClientToModelStoreFilter::onInputReady(std::vector<CDataPacketPtr> data)
+  {
+
+    CDataPacketPtr packet;
+    if (detectMissingValues_)
+    {
+      const size_t nbData = data[0]->data.numElements();
+
+      packet = CDataPacketPtr(new CDataPacket);
+      packet->date = data[0]->date;
+      packet->timestamp = data[0]->timestamp;
+      packet->status = data[0]->status;
+      packet->data.resize(nbData);
+      packet->data = data[0]->data;
+
+      for (size_t idx = 0; idx < nbData; ++idx)
+      {
+        if (NumTraits<double>::isNan(packet->data(idx)))
+          packet->data(idx) = missingValue_;
+      }
+
+    }
+
+    else
+    {
+      packet = data[0];
+    }
+
+    packets_.insert(std::make_pair(packet->timestamp, packet));
+    // The packet is always destroyed by the garbage collector
+    // so we register but never unregister
+    gc_.registerObject(this, packet->timestamp);
+
+  }
+
+  bool CClientToModelStoreFilter::mustAutoTrigger() const
+  {
+    return false;
+  }
+
+  bool CClientToModelStoreFilter::isDataExpected(const CDate& date) const
+  {
+    return true;
+  }
+
+  void CClientToModelStoreFilter::invalidate(Time timestamp)
+  {
+    CInputPin::invalidate(timestamp);
+    packets_.erase(packets_.begin(), packets_.lower_bound(timestamp));
+  }
+} // namespace xios
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_to_model_store_filter.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_to_model_store_filter.hpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_to_model_store_filter.hpp	(revision 1930)
@@ -0,0 +1,94 @@
+#ifndef __XIOS_CStoreFilter__
+#define __XIOS_CStoreFilter__
+
+#include "input_pin.hpp"
+
+namespace xios
+{
+  class CContext;
+  class CGrid;
+  class CField ;
+
+  /*!
+   * A terminal filter which stores all the packets it receives.
+   */
+  class CClientToModelStoreFilter : public CInputPin
+  {
+    public:
+      /*!
+       * Constructs the filter with one input slot and an associated
+       * garbage collector for the specified grid and context.
+       *
+       * \param gc the garbage collector associated with this input pin
+       * \param context the context to which the data belongs
+       * \param grid the grid to which the data is attached
+       * \param detectMissingValues whether missing values should be detected
+       * \param missingValue the value to use to replace missing values
+       */
+      CClientToModelStoreFilter(CGarbageCollector& gc, CField* field);
+
+      /*!
+       * Accesses the filter storage and retuns the packet corresponding
+       * to the specified timestamp. If there is no packet available for
+       * the specified timestamp, the function waits until the data is
+       * received or a timeout occurs.
+       *
+       * \param timestamp the timestamp of the requested packet
+       * \return a pointer to a read-only packet
+       */
+      CConstDataPacketPtr getPacket(Time timestamp);
+
+      /*!
+       * Accesses the filter storage and retuns the data corresponding
+       * to the specified timestamp. If there is no data available for
+       * the specified timestamp, the function waits until the data is
+       * received or a timeout occurs.
+       *
+       * \param timestamp the timestamp of the requested data
+       * \param data the array where the data is to be copied
+       * \return the status code associated with the data
+       */
+      template <int N>
+      CDataPacket::StatusCode getData(Time timestamp, CArray<double, N>& data);
+
+      /*!
+       * Tests if the filter must auto-trigger.
+       *
+       * \return true if the filter must auto-trigger
+       */
+      bool virtual mustAutoTrigger() const;
+
+      /*!
+       * Tests whether data is expected for the specified date.
+       *
+       * \param date the date associated to the data
+       */
+      bool virtual isDataExpected(const CDate& date) const;
+
+      /*!
+       * Removes all pending packets which are older than the specified timestamp.
+       *
+       * \param timestamp the timestamp used for invalidation
+       */
+      void virtual invalidate(Time timestamp);
+
+    protected:
+      /*!
+       * Stores the packet for later access.
+       *
+       * \param data a vector of packets corresponding to each slot
+       */
+      void virtual onInputReady(std::vector<CDataPacketPtr> data);
+
+    private:
+      CGarbageCollector& gc_; //!< The garbage collector associated to the filter
+      CContext* context_; //!< The context to which the data belongs
+      CGrid* grid_; //!< The grid attached to the data the filter can accept
+      bool detectMissingValues_; //!< Whether missing values should be detected
+      double missingValue_; //!< The value to use to replace missing values
+      bool hasMissingValue_ ;
+      std::map<Time, CDataPacketPtr> packets_; //<! The stored packets
+  }; // class CClientToModelStoreFilter
+} // namespace xios
+
+#endif //__XIOS_CStoreFilter__
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/data_packet.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/data_packet.hpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/data_packet.hpp	(revision 1930)
@@ -32,5 +32,6 @@
      * \return a deep copy of the packet
      */
-    CDataPacket* copy() const {
+    CDataPacket* copy() const 
+    {
       CDataPacket* p = new CDataPacket;
       p->data.resize(data.shape());
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/file_reader_source_filter.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/file_reader_source_filter.cpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/file_reader_source_filter.cpp	(revision 1930)
@@ -0,0 +1,75 @@
+#include "file_reader_source_filter.hpp"
+#include "grid.hpp"
+#include "exception.hpp"
+#include "calendar_util.hpp"
+#include "context.hpp"
+#include "field.hpp"
+#include "file.hpp"
+#include "context.hpp"
+
+
+namespace xios
+{
+  CFileReaderSourceFilter::CFileReaderSourceFilter(CGarbageCollector& gc, CField* field)
+    : COutputPin(gc)
+  {
+    field_ = field ;
+    grid_ = field->getGrid() ;
+    file_ = field->getFileIn() ;
+    if (!file_->cyclic.isEmpty()) isCyclic_ = file_->cyclic ;
+    if (!field_->scale_factor.isEmpty()) { hasScaleFactor_=true ; scaleFactor_ = field_->scale_factor ; }
+    if (!field_->add_offset.isEmpty()) { hasAddOffset_=true ; addOffset_ = field_->add_offset ; }
+  }
+
+  void CFileReaderSourceFilter::streamData()
+  {
+    Time timeStamp ;
+    CDataPacketPtr packet(new CDataPacket);
+    packet->date = CContext::getCurrent()->getCalendar()->getCurrentDate();
+    packet->timestamp = timeStamp;
+    packet->status = CDataPacket::NO_ERROR;
+
+    CArray<double,1> data ;
+    if (!isInitialized_)  initialize() ;
+    CField::EReadField readState = CField::RF_DATA;
+
+    if ( nStepMax_==0 || (nStep_ >= nStepMax_ && !isCyclic_)) readState = CField::RF_EOF;
+  
+    if (CField::RF_EOF != readState)
+    {
+      if (file_->isEmptyZone()) readData(data) ;
+      else readState = CField::RF_NODATA;
+    }
+    nStep_++ ;
+    
+    if (readState == CField::RF_DATA) packet->status = CDataPacket::NO_ERROR;
+    else packet->status = CDataPacket::END_OF_STREAM;
+            
+    onOutputReady(packet);
+  }
+
+  void CFileReaderSourceFilter::initialize()
+  {
+    CContext* context = CContext::getCurrent();
+    file_->initRead();
+    if (file_->isEmptyZone())
+    {      
+      file_->checkReadFile();
+      nStepMax_ = file_->getDataInput()->getFieldNbRecords(field_);
+      nStep_ = 0 ;
+    }
+    MPI_Allreduce(MPI_IN_PLACE, &nStepMax_, 1, MPI_INT, MPI_MAX, context->getIntraComm());
+  }
+
+  void CFileReaderSourceFilter::readData(CArray<double,1>& data)
+  {
+    CGridLocalConnector*  connector = grid_->getFullToWorkflowConnector() ;
+    CArray<double,1> dataIn(connector->getDstSize()) ;
+    file_->getDataInput()->readFieldData(field_, nStep_%nStepMax_, dataIn);
+    connector->transfer(dataIn, data) ; 
+
+    if (hasScaleFactor_ || hasAddOffset_) data = data * scaleFactor_ + addOffset_; // possibility of optimization
+  }
+ 
+  
+} // namespace xios
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/file_reader_source_filter.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/file_reader_source_filter.hpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/file_reader_source_filter.hpp	(revision 1930)
@@ -0,0 +1,54 @@
+#ifndef __XIOS_FILE_READER_SOURCE_FILTER__
+#define __XIOS_FILE_READER_SOURCE_FILTER__
+
+#include "output_pin.hpp"
+
+namespace xios
+{
+  class CField;
+  class CFile ;
+  class CGrid ;
+
+  /*!
+   * A source filter is the entry point of the data in the graph of filters.
+   */
+  class CFileReaderSourceFilter : public COutputPin
+  {
+    public:
+      /*!
+       * Constructs a source filter accepting data attached to the specified grid.
+       *
+       * \param gc the garbage collector associated with this filter
+       * \param field the field to which the data is related
+       */
+      CFileReaderSourceFilter(CGarbageCollector& gc, CField* field);
+
+      /*!
+       * Transforms the data received from the model into a packet and send it
+       * in the filter graph. The array containing the data can safely be reused
+       * immediately after this method returns.
+       *
+       * \param date the date associated to the data
+       * \param data an array containing the data
+       */
+      void streamData(void);
+      void initialize(void) ;
+      void readData(CArray<double,1>& data) ;
+
+    private:
+      CGrid* grid_;             //!< The grid attached to the data the filter can accept
+      CField* field_ ;
+      CFile* file_ ;
+      bool hasScaleFactor_ = false;
+      bool hasAddOffset_ = false ;
+      bool isInitialized_ = false ;
+      bool isCyclic_ = false ;
+      double scaleFactor_= 1.0 ;
+      double addOffset_= 0. ;
+      int nStepMax_ ;
+      int nStep_ ;
+
+  }; // class CFileReaderSourceFilter
+} // namespace xios
+
+#endif // __XIOS_FILE_READER_SOURCE_FILTER__
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/model_to_client_source_filter.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/model_to_client_source_filter.cpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/model_to_client_source_filter.cpp	(revision 1930)
@@ -0,0 +1,58 @@
+#include "model_to_client_source_filter.hpp"
+#include "grid.hpp"
+#include "exception.hpp"
+#include "calendar_util.hpp"
+#include <limits> 
+
+namespace xios
+{
+  CModelToClientSourceFilter::CModelToClientSourceFilter(CGarbageCollector& gc, CGrid* grid, bool hasMissingValue, double defaultValue)
+    : COutputPin(gc)
+    , grid_(grid)
+    , hasMissingValue_(hasMissingValue), defaultValue_(defaultValue)
+  {
+    if (!grid)
+      ERROR("CSourceFilter::CSourceFilter(CGrid* grid)",
+            "Impossible to construct a source filter without providing a grid.");
+  }
+
+  template <int N>
+  void CModelToClientSourceFilter::streamData(CDate date, const CArray<double, N>& data)
+  {
+    CDataPacketPtr packet(new CDataPacket);
+    packet->date = date;
+    packet->timestamp = date;
+    packet->status = CDataPacket::NO_ERROR;
+    
+    auto connector = grid_->getModelToWorkflowConnector() ;
+
+    if (connector->getSrcSize() != data.numElements())
+      ERROR("void CModelToClientSourceFilter::streamData(CDate date, const CArray<double, N>& data)",
+            << "[ Awaiting data of size = " <<connector->getSrcSize() << ", "
+            << "Received data size = "      << data.numElements() << " ] "
+            << "The data array does not have the right size! "
+            << "grid = " << grid_->getId())
+    const double nanValue = std::numeric_limits<double>::quiet_NaN();
+    packet->data.resize(connector->getDstSize()) ;
+    connector->transfer(data, packet->data, nanValue) ;
+
+    if (hasMissingValue_)
+    {
+        const double nanValue = std::numeric_limits<double>::quiet_NaN();
+        const size_t nbData = packet->data.numElements();
+        for (size_t idx = 0; idx < nbData; ++idx)
+          if (defaultValue_ == packet->data(idx))   packet->data(idx) = nanValue;
+    }
+    
+    onOutputReady(packet);
+  }
+
+  template void CModelToClientSourceFilter::streamData<1>(CDate date, const CArray<double, 1>& data);
+  template void CModelToClientSourceFilter::streamData<2>(CDate date, const CArray<double, 2>& data);
+  template void CModelToClientSourceFilter::streamData<3>(CDate date, const CArray<double, 3>& data);
+  template void CModelToClientSourceFilter::streamData<4>(CDate date, const CArray<double, 4>& data);
+  template void CModelToClientSourceFilter::streamData<5>(CDate date, const CArray<double, 5>& data);
+  template void CModelToClientSourceFilter::streamData<6>(CDate date, const CArray<double, 6>& data);
+  template void CModelToClientSourceFilter::streamData<7>(CDate date, const CArray<double, 7>& data);
+
+} // namespace xios
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/model_to_client_source_filter.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/model_to_client_source_filter.hpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/model_to_client_source_filter.hpp	(revision 1930)
@@ -0,0 +1,55 @@
+#ifndef __XIOS_MODEL_TO_CLIENT_SOURCE_FILTER_HPP__
+#define __XIOS_MODEL_TO_CLIENT_SOURCE_FILTER_HPP__
+
+#include <map>
+
+#include "output_pin.hpp"
+
+namespace xios
+{
+  class CGrid;
+
+  /*!
+   * A source filter is the entry point of the data in the graph of filters.
+   */
+  class CModelToClientSourceFilter : public COutputPin
+  {
+    public:
+      /*!
+       * Constructs a source filter accepting data attached to the specified grid.
+       *
+       * \param gc the garbage collector associated with this filter
+       * \param grid the grid to which the data is attached
+       * \param hasMissingValue whether data has missing value
+       * \param defaultValue missing value to detect
+       */
+      CModelToClientSourceFilter(CGarbageCollector& gc, CGrid* grid, bool hasMissingValue = false, double defaultValue = 0.0);
+
+      /*!
+       * Transforms the data received from the model into a packet and send it
+       * in the filter graph. The array containing the data can safely be reused
+       * immediately after this method returns.
+       *
+       * \param date the date associated to the data
+       * \param data an array containing the data
+       */
+      template <int N>
+      void streamData(CDate date, const CArray<double, N>& data);
+
+      /*!
+       * Transforms the data received from the server into a packet and send it
+       * in the filter graph. The array containing the data can safely be reused
+       * immediately after this method returns.
+       *
+       * \param date the date associated to the data
+       * \param data an array containing the data
+       */
+
+    private:
+      CGrid* grid_;             //!< The grid attached to the data the filter can accept
+      const bool hasMissingValue_;
+      const double defaultValue_;
+  }; // class CSourceFilter
+} // namespace xios
+
+#endif // __XIOS_MODEL_TO_CLIENT_SOURCE_FILTER_HPP__
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/server_from_client_source_filter.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/server_from_client_source_filter.cpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/server_from_client_source_filter.cpp	(revision 1930)
@@ -0,0 +1,34 @@
+#include "server_from_client_source_filter.hpp"
+#include "grid.hpp"
+#include "exception.hpp"
+#include "calendar_util.hpp"
+#include "context.hpp"
+
+
+namespace xios
+{
+  CServerFromClientSourceFilter::CServerFromClientSourceFilter(CGarbageCollector& gc, CGrid* grid)
+    : COutputPin(gc)
+    , grid_(grid)
+  {
+    if (!grid_)
+      ERROR("CServerFromClientSourceFilter::CServerFromClientSourceFilter(CGarbageCollector& gc, CGrid* grid)",
+            "Impossible to construct a source filter without providing a grid.");
+  }
+
+  void CServerFromClientSourceFilter::streamData(CEventServer& event)
+  {
+    Time timeStamp ;
+    for (auto& subEvent : event.subEvents) (*subEvent.buffer) >> timeStamp  ;
+    CDataPacketPtr packet(new CDataPacket);
+    packet->date = CContext::getCurrent()->getCalendar()->getTimeOrigin() + timeStamp*Second; // very bad, better to pass directly the date
+    packet->timestamp = timeStamp;
+    packet->status = CDataPacket::NO_ERROR;
+    grid_->getServerFromClientConnector()->transfer(event,packet->data) ;
+
+    onOutputReady(packet);
+  }
+
+ 
+  
+} // namespace xios
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/server_from_client_source_filter.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/server_from_client_source_filter.hpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/server_from_client_source_filter.hpp	(revision 1930)
@@ -0,0 +1,47 @@
+#ifndef __XIOS_SERVER_FROM_CLIENT_SOURCE_FILTER__
+#define __XIOS_SERVER_FROM_CLIENT_SOURCE_FILTER__
+
+#include "output_pin.hpp"
+#include "event_server.hpp"
+
+namespace xios
+{
+  class CGrid;
+
+  /*!
+   * A source filter is the entry point of the data in the graph of filters.
+   */
+  class CServerFromClientSourceFilter : public COutputPin
+  {
+    public:
+      /*!
+       * Constructs a source filter accepting data attached to the specified grid.
+       *
+       * \param gc the garbage collector associated with this filter
+       * \param grid the grid to which the data is attached
+       * \param compression
+       * \param mask
+       * \param offset the offset applied to the timestamp of all packets
+       * \param manualTrigger whether the output should be triggered manually
+       * \param hasMissingValue whether data has missing value
+       * \param defaultValue missing value to detect
+       */
+      CServerFromClientSourceFilter(CGarbageCollector& gc, CGrid* grid);
+
+      /*!
+       * Transforms the data received from the model into a packet and send it
+       * in the filter graph. The array containing the data can safely be reused
+       * immediately after this method returns.
+       *
+       * \param date the date associated to the data
+       * \param data an array containing the data
+       */
+      void streamData(CEventServer& event);
+
+    private:
+      CGrid* grid_;             //!< The grid attached to the data the filter can accept
+
+  }; // class CServerFromClientSourceFilter
+} // namespace xios
+
+#endif // __XIOS_SERVER_FROM_CLIENT_SOURCE_FILTER__
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/source_filter.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/source_filter.cpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/source_filter.cpp	(revision 1930)
@@ -40,19 +40,26 @@
       packet->data = defaultValue;
       grid->uncompressField(data, packet->data);    
+      
+      // Convert missing values to NaN
+      if (hasMissingValue) // probably to removed later
+      {
+        const double nanValue = std::numeric_limits<double>::quiet_NaN();
+        const size_t nbData = packet->data.numElements();
+        for (size_t idx = 0; idx < nbData; ++idx)
+        {
+          if (defaultValue == packet->data(idx))
+          packet->data(idx) = nanValue;
+        }
+      }
     }
     else
     {
-      if (mask) grid->maskField(data, packet->data);
-      else grid->inputField(data, packet->data);
-    }
-    // Convert missing values to NaN
-    if (hasMissingValue)
-    {
-      const double nanValue = std::numeric_limits<double>::quiet_NaN();
-      const size_t nbData = packet->data.numElements();
-      for (size_t idx = 0; idx < nbData; ++idx)
+      if (mask) grid->maskField(data, packet->data);       // => ie coming from model
+      //else grid->inputField(data, packet->data);
+      else 
       {
-        if (defaultValue == packet->data(idx))
-          packet->data(idx) = nanValue;
+        packet->data.resize(data.numElements()) ; // temporary solution, create own source filter for data coming from client
+        CArray<double,1> tmp( (double*)data.dataFirst(),shape(data.numElements()),duplicateData) ;
+        packet->data.reference(tmp) ;   // nothing to do if coming from client to server => workflow view
       }
     }
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/io/nc4_data_input.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/io/nc4_data_input.cpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/io/nc4_data_input.cpp	(revision 1930)
@@ -43,5 +43,5 @@
   CATCH
 
-  void CNc4DataInput::readFieldData_(CField* field, CArray<double,1>& dataOut)
+  void CNc4DataInput::readFieldData_(CField* field, int record, CArray<double,1>& dataOut)
   TRY
   {
@@ -50,16 +50,12 @@
     CGrid* grid = field->getGrid();
 
-    if (!grid->doGridHaveDataToWrite())
-      if (SuperClass::type==MULTI_FILE || !isCollective) return;
+    if (!grid->doGridHaveDataToWrite())  if (SuperClass::type==MULTI_FILE || !isCollective) return;
 
     StdString fieldId = field->getFieldOutputName();
 
-    CArray<double,1> fieldData(grid->getWrittenDataSize());
-    if (!field->default_value.isEmpty()) fieldData = field->default_value;
-
     switch (SuperClass::type)
     {
       case MULTI_FILE:
-        SuperClassWriter::getData(fieldData, fieldId, isCollective, (field->getNStep() - 1)%field->nstepMax );
+        SuperClassWriter::getData(dataOut, fieldId, isCollective, record );
         break;
       case ONE_FILE:
@@ -108,17 +104,7 @@
         }
 
-        SuperClassWriter::getData(fieldData, fieldId, isCollective, (field->getNStep() - 1)%field->nstepMax, &start, &count);
+        SuperClassWriter::getData(dataOut, fieldId, isCollective, record, &start, &count);
         break;
       }
-    }
-
-    field->inputField(fieldData, dataOut);
-
-    if (!field->scale_factor.isEmpty() || !field->add_offset.isEmpty())
-    {
-      double scaleFactor = 1.0, addOffset = 0.0;
-      if (!field->scale_factor.isEmpty()) scaleFactor = field->scale_factor;
-      if (!field->add_offset.isEmpty()) addOffset = field->add_offset;
-      field->invertScaleFactorAddOffset(dataOut,scaleFactor, addOffset);
     }
   }
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/io/nc4_data_input.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/io/nc4_data_input.hpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/io/nc4_data_input.hpp	(revision 1930)
@@ -37,5 +37,5 @@
     // Read methods
     virtual StdSize getFieldNbRecords_(CField* field);
-    virtual void readFieldData_(CField* field, CArray<double,1>& data);
+    virtual void readFieldData_(CField* field, int record, CArray<double,1>& data);
     virtual void readFieldAttributes_(CField* field, bool readAttributeValues);
     virtual void closeFile_(void);
